deploy:
  stage: deploy
  before_script:
    - export IMAGE_NAME=$CI_REGISTRY_IMAGE
    - export IMAGE_TAG=$SERVICE_VERSION
    - export MICRO_SERVICE=$MICRO_SERVICE
    - export SERVICE_PORT=$SERVICE_PORT
    - export REPLICAS=$REPLICAS
    - export KUBECONFIG=$KUBE_CONFIG
    - echo "Check Access to the K8s cluster"
    - kubectl -n $NAMESPACE get secret
  script:
    - echo "GitLab DockerRegistry Credentials"
    - >
      kubectl -n $NAMESPACE create secret docker-registry registry-credentials
      --docker-server=$CI_REGISTRY
      --docker-username=$REGISTRY_CRED_USER
      --docker-password=$REGISTRY_CRED_PASS
      --dry-run=client -o yaml > registry-credentials.yml
    - kubectl apply -f registry-credentials.yml
    - echo "Apply Deployment and Service for $MICRO_SERVICE"
    - envsubst < kubernetes/deployment.yml | kubectl apply -f -
    - envsubst < kubernetes/service.yml | kubectl apply -f -

